/*
*  Copyright (C) 1998-2022 by Northwoods Software Corporation. All Rights Reserved.
*
*  Restricted Rights: Use, duplication, or disclosure by the U.S.
*  Government is subject to restrictions as set forth in subparagraph
*  (c) (1) (ii) of DFARS 252.227-7013, or in FAR 52.227-19, or in FAR
*  52.227-14 Alt. III, as applicable.
*
*  This software is proprietary to and embodies the confidential
*  technology of Northwoods Software Corporation. Possession, use, or
*  copying of this software and media is authorized only pursuant to a
*  valid written license from Northwoods or an authorized sublicensor.
*/
(function() {
  var $ = go.GraphObject.make;

  var dts = new TestCollection('.d.ts test');
  TestRoot.add(dts);

  dts.add(new Test('Test methods/props exposure', null,
  function (test) {
    var allClasses = {
      
"EnumValue": [
'classType',
'name',
],


"List": [
'toString',
'add',
'push',
'addAll',
'clear',
'contains',
'has',
'indexOf',
'elt',
'get',
'setElt',
'set',
'first',
'last',
'pop',
'any',
'all',
'each',
'map',
'filter',
'insertAt',
'remove',
'delete',
'removeAt',
'removeRange',
'copy',
'toArray',
'toSet',
'sort',
'sortRange',
'reverse',
'count',
'size',
'length',
'iterator',
'iteratorBackwards',
],
"Set": [
'toString',
'add',
'addAll',
'contains',
'has',
'containsAll',
'containsAny',
'first',
'any',
'all',
'each',
'map',
'filter',
'remove',
'delete',
'removeAll',
'retainAll',
'clear',
'copy',
'toArray',
'toList',
'count',
'size',
'iterator',
'static uniqueHash',
'static hashIdUnique',
'static hashId',
],
"Map": [
'toString',
'add',
'set',
'addAll',
'first',
'any',
'all',
'each',
'map',
'filter',
'contains',
'has',
'getValue',
'get',
'remove',
'delete',
'clear',
'copy',
'toArray',
'toKeySet',
'count',
'size',
'iterator',
'iteratorKeys',
'iteratorValues',
],
"Point": [
'setTo',
'set',
'copy',
'static parse',
'static stringify',
'equals',
'equalTo',
'equalsApprox',
'add',
'subtract',
'offset',
'rotate',
'scale',
'distanceSquaredPoint',
'distanceSquared',
'normalize',
'directionPoint',
'direction',
'static compareWithLineSegment',
'compareWithLineSegmentPoint',
'static intersectingLineSegments',
'projectOntoLineSegment',
'projectOntoLineSegmentPoint',
'snapToGrid',
'snapToGridPoint',
'setRectSpot',
'setSpot',
'static distanceLineSegmentSquared',
'static distanceSquared',
'static direction',
'x',
'x',
'y',
'y',
'isReal',
'static alloc',
'static allocAt',
'static free',
],
"Size": [
'setTo',
'set',
'copy',
'static parse',
'static stringify',
'equals',
'equalTo',
'equalsApprox',
'width',
'width',
'height',
'height',
'isReal',
'static alloc',
'static free',
],
"Rect": [
'setTo',
'set',
'setPoint',
'setSize',
'copy',
'static parse',
'static stringify',
'equals',
'equalTo',
'equalsApprox',
'containsPoint',
'containsRect',
'contains',
'offset',
'inflate',
'addMargin',
'subtractMargin',
'grow',
'intersectRect',
'intersect',
'intersectsRect',
'intersects',
'unionPoint',
'unionRect',
'union',
'setSpot',
'static contains',
'static intersects',
'static intersectsLineSegment',
'x',
'x',
'y',
'y',
'width',
'width',
'height',
'height',
'left',
'left',
'top',
'top',
'right',
'right',
'bottom',
'bottom',
'position',
'position',
'size',
'size',
'center',
'center',
'centerX',
'centerX',
'centerY',
'centerY',
'isReal',
'isEmpty',
'static alloc',
'static allocAt',
'static free',
],
"Margin": [
'setTo',
'set',
'copy',
'static parse',
'static stringify',
'equals',
'equalTo',
'equalsApprox',
'top',
'top',
'right',
'right',
'bottom',
'bottom',
'left',
'left',
'isReal',
'static alloc',
'static free',
],
"Spot": [
'setTo',
'set',
'copy',
'static parse',
'static stringify',
'equals',
'opposite',
'includesSide',
'x',
'x',
'y',
'y',
'offsetX',
'offsetX',
'offsetY',
'offsetY',
'isSpot',
'isNoSpot',
'isSide',
'isNone',
'isDefault',
'static None',
'static Default',
'static TopLeft',
'static TopCenter',
'static TopRight',
'static LeftCenter',
'static Center',
'static RightCenter',
'static BottomLeft',
'static BottomCenter',
'static BottomRight',
'static MiddleTop',
'static MiddleLeft',
'static MiddleRight',
'static MiddleBottom',
'static Top',
'static Left',
'static Right',
'static Bottom',
'static TopSide',
'static LeftSide',
'static RightSide',
'static BottomSide',
'static TopBottomSides',
'static LeftRightSides',
'static TopLeftSides',
'static TopRightSides',
'static BottomLeftSides',
'static BottomRightSides',
'static NotTopSide',
'static NotLeftSide',
'static NotRightSide',
'static NotBottomSide',
'static AllSides',
'static alloc',
'static free',
],
"Geometry": [
'copy',
'static Line',
'static Rectangle',
'static Ellipse',
'static Path',
'equalsApprox',
'static stringify',
'static fillPath',
'static parse',
'computeBoundsWithoutOrigin',
'normalize',
'offset',
'scale',
'rotate',
'containsPoint',
'getPointAlongPath',
'getAngleAlongPath',
'getFractionForPoint',
'flattenedSegments',
'flattenedLengths',
'flattenedTotalLength',
'type',
'type',
'startX',
'startX',
'startY',
'startY',
'endX',
'endX',
'endY',
'endY',
'figures',
'figures',
'add',
'setSpots',
'spot1',
'spot1',
'spot2',
'spot2',
'defaultStretch',
'defaultStretch',
'bounds',
],
"PathFigure": [
'copy',
'equalsApprox',
'isFilled',
'isFilled',
'isShadowed',
'isShadowed',
'startX',
'startX',
'startY',
'startY',
'segments',
'segments',
'add',
],
"PathSegment": [
'copy',
'equalsApprox',
'static Move',
'static Line',
'static Bezier',
'static QuadraticBezier',
'static Arc',
'static SvgArc',
'close',
'isClosed',
'isClosed',
'type',
'type',
'endX',
'endX',
'endY',
'endY',
'point1X',
'point1X',
'point1Y',
'point1Y',
'point2X',
'point2X',
'point2Y',
'point2Y',
'centerX',
'centerX',
'centerY',
'centerY',
'radiusX',
'radiusX',
'radiusY',
'radiusY',
'startAngle',
'startAngle',
'sweepAngle',
'sweepAngle',
'isClockwiseArc',
'isClockwiseArc',
'isLargeArc',
'isLargeArc',
'xAxisRotation',
'xAxisRotation',
],
"InputEvent": [
'copy',
'diagram',
'diagram',
'viewPoint',
'viewPoint',
'documentPoint',
'documentPoint',
'modifiers',
'modifiers',
'button',
'button',
'buttons',
'buttons',
'key',
'key',
'down',
'down',
'up',
'up',
'clickCount',
'clickCount',
'delta',
'delta',
'isMultiTouch',
'isMultiTouch',
'handled',
'handled',
'bubbles',
'bubbles',
'event',
'event',
'isTouchEvent',
'timestamp',
'timestamp',
'targetDiagram',
'targetDiagram',
'targetObject',
'targetObject',
'control',
'control',
'shift',
'shift',
'alt',
'alt',
'meta',
'meta',
'left',
'left',
'right',
'right',
'middle',
'middle',
],
"DiagramEvent": [
'diagram',
'diagram',
'name',
'name',
'subject',
'subject',
'parameter',
'parameter',
],

"ChangedEvent": [
'static Transaction',
'static Property',
'static Insert',
'static Remove',
'clear',
'copy',
'getValue',
'getParam',
'canUndo',
'undo',
'canRedo',
'redo',
'model',
'model',
'diagram',
'diagram',
'change',
'change',
'modelChange',
'modelChange',
'propertyName',
'propertyName',
'isTransactionFinished',
'object',
'object',
'oldValue',
'oldValue',
'oldParam',
'oldParam',
'newValue',
'newValue',
'newParam',
'newParam',
],
"Transaction": [
'clear',
'canUndo',
'undo',
'canRedo',
'redo',
'optimize',
'changes',
'name',
'name',
'isComplete',
'isComplete',
],
"UndoManager": [
'clear',
'copyProperties',
'addModel',
'removeModel',
'startTransaction',
'commitTransaction',
'rollbackTransaction',
'canUndo',
'undo',
'canRedo',
'redo',
'handleChanged',
'skipsEvent',
'models',
'isEnabled',
'isEnabled',
'transactionToUndo',
'transactionToRedo',
'isUndoingRedoing',
'history',
'maxHistoryLength',
'maxHistoryLength',
'historyIndex',
'currentTransaction',
'transactionLevel',
'isInTransaction',
'checksTransactionLevel',
'nestedTransactionNames',
],
"Tool": [
'diagram',
'diagram',
'updateAdornments',
'canStart',
'doStart',
'doActivate',
'doDeactivate',
'doStop',
'doCancel',
'stopTool',
'doMouseDown',
'doMouseMove',
'doMouseUp',
'doMouseWheel',
'canStartMultiTouch',
'standardPinchZoomStart',
'standardPinchZoomMove',
'doKeyDown',
'doKeyUp',
'startTransaction',
'stopTransaction',
'standardMouseSelect',
'standardMouseClick',
'standardMouseOver',
'standardMouseWheel',
'standardWaitAfter',
'cancelWaitAfter',
'doWaitAfter',
'findToolHandleAt',
'isBeyondDragSize',
'name',
'name',
'isEnabled',
'isEnabled',
'isActive',
'isActive',
'transactionResult',
'transactionResult',
],
"ToolManager": [
'static WheelScroll',
'static WheelZoom',
'static WheelNone',
'static GestureZoom',
'static GestureCancel',
'static GestureNone',
'mouseWheelBehavior',
'mouseWheelBehavior',
'gestureBehavior',
'gestureBehavior',
'initializeStandardTools',
'doMouseDown',
'doMouseMove',
'doWaitAfter',
'doMouseHover',
'doToolTip',
'showToolTip',
'positionToolTip',
'hideToolTip',
'currentToolTip',
'currentToolTip',
'doMouseUp',
'doMouseWheel',
'doKeyDown',
'doKeyUp',
'findTool',
'replaceTool',
'replaceStandardTool',
'mouseDownTools',
'mouseMoveTools',
'mouseUpTools',
'hoverDelay',
'hoverDelay',
'holdDelay',
'holdDelay',
'dragSize',
'dragSize',
'toolTipDuration',
'toolTipDuration',
'actionTool',
'actionTool',
'relinkingTool',
'relinkingTool',
'linkReshapingTool',
'linkReshapingTool',
'resizingTool',
'resizingTool',
'rotatingTool',
'rotatingTool',
'linkingTool',
'linkingTool',
'draggingTool',
'draggingTool',
'dragSelectingTool',
'dragSelectingTool',
'panningTool',
'panningTool',
'contextMenuTool',
'contextMenuTool',
'textEditingTool',
'textEditingTool',
'clickCreatingTool',
'clickCreatingTool',
'clickSelectingTool',
'clickSelectingTool',
],
"DraggingTool": [
'isCopyEnabled',
'isCopyEnabled',
'copiesEffectiveCollection',
'copiesEffectiveCollection',
'dragOptions',
'dragOptions',
'isGridSnapEnabled',
'isGridSnapEnabled',
'isComplexRoutingRealtime',
'isComplexRoutingRealtime',
'isGridSnapRealtime',
'isGridSnapRealtime',
'gridSnapCellSize',
'gridSnapCellSize',
'gridSnapCellSpot',
'gridSnapCellSpot',
'gridSnapOrigin',
'gridSnapOrigin',
'dragsLink',
'dragsLink',
'dragsTree',
'dragsTree',
'copyCursor',
'copyCursor',
'moveCursor',
'moveCursor',
'nodropCursor',
'nodropCursor',
'currentPart',
'currentPart',
'copiedParts',
'copiedParts',
'draggedParts',
'draggedParts',
'draggingParts',
'draggedLink',
'isDragOutStarted',
'startPoint',
'startPoint',
'delay',
'delay',
'canStart',
'findDraggablePart',
'standardMouseSelect',
'doActivate',
'computeEffectiveCollection',
'doDeactivate',
'stopTransaction',
'doCancel',
'doKeyDown',
'doKeyUp',
'moveParts',
'findDragOverObject',
'doDragOver',
'doDropOnto',
'doMouseMove',
'doMouseUp',
'simulatedMouseMove',
'simulatedMouseUp',
'mayCopy',
'mayMove',
'computeMove',
],
"LinkingBaseTool": [
'portGravity',
'portGravity',
'isUnconnectedLinkValid',
'isUnconnectedLinkValid',
'linkingCursor',
'linkingCursor',
'temporaryLink',
'temporaryLink',
'temporaryFromNode',
'temporaryFromNode',
'temporaryFromPort',
'temporaryFromPort',
'temporaryToNode',
'temporaryToNode',
'temporaryToPort',
'temporaryToPort',
'originalLink',
'originalLink',
'originalFromNode',
'originalFromNode',
'originalFromPort',
'originalFromPort',
'originalToNode',
'originalToNode',
'originalToPort',
'originalToPort',
'isForwards',
'isForwards',
'targetPort',
'targetPort',
'copyPortProperties',
'setNoTargetPortProperties',
'doMouseMove',
'findTargetPort',
'isValidFrom',
'isValidTo',
'isInSameNode',
'isLinked',
'isValidLink',
'isValidCycle',
'linkValidation',
'linkValidation',
'portTargeted',
'portTargeted',
],
"LinkingTool": [
'static Either',
'static ForwardsOnly',
'static BackwardsOnly',
'archetypeLinkData',
'archetypeLinkData',
'archetypeLabelNodeData',
'archetypeLabelNodeData',
'direction',
'direction',
'startObject',
'startObject',
'canStart',
'findLinkablePort',
'doActivate',
'doDeactivate',
'doMouseUp',
'insertLink',
'doNoLink',
],
"RelinkingTool": [
'updateAdornments',
'makeAdornment',
'fromHandleArchetype',
'fromHandleArchetype',
'toHandleArchetype',
'toHandleArchetype',
'handle',
'handle',
'canStart',
'doActivate',
'copyLinkProperties',
'doDeactivate',
'doMouseUp',
'reconnectLink',
'doNoRelink',
],
"LinkReshapingTool": [
'static None',
'static Horizontal',
'static Vertical',
'static All',
'getReshapingBehavior',
'setReshapingBehavior',
'updateAdornments',
'makeAdornment',
'makeHandle',
'handleArchetype',
'handleArchetype',
'makeResegmentHandle',
'midHandleArchetype',
'midHandleArchetype',
'handle',
'handle',
'adornedLink',
'canStart',
'doActivate',
'doDeactivate',
'stopTransaction',
'doCancel',
'getResegmentingPoint',
'doMouseMove',
'doMouseUp',
'resegmentingDistance',
'reshape',
'computeReshape',
'originalPoint',
'originalPoints',
],
"ResizingTool": [
'updateAdornments',
'makeAdornment',
'updateResizeHandles',
'handleArchetype',
'handleArchetype',
'handle',
'handle',
'adornedObject',
'adornedObject',
'canStart',
'doActivate',
'doDeactivate',
'stopTransaction',
'doCancel',
'doMouseMove',
'doMouseUp',
'resize',
'computeResize',
'computeReshape',
'computeMinSize',
'computeMaxSize',
'computeCellSize',
'minSize',
'minSize',
'maxSize',
'maxSize',
'cellSize',
'cellSize',
'isGridSnapEnabled',
'isGridSnapEnabled',
'dragsMembers',
'dragsMembers',
'oppositePoint',
'oppositePoint',
'originalDesiredSize',
'originalLocation',
],
"RotatingTool": [
'updateAdornments',
'makeAdornment',
'handleArchetype',
'handleArchetype',
'handle',
'handle',
'adornedObject',
'adornedObject',
'canStart',
'doActivate',
'computeRotationPoint',
'doDeactivate',
'stopTransaction',
'doCancel',
'doMouseMove',
'doMouseUp',
'rotate',
'computeRotate',
'snapAngleMultiple',
'snapAngleMultiple',
'snapAngleEpsilon',
'snapAngleEpsilon',
'originalAngle',
'rotationPoint',
'rotationPoint',
'handleAngle',
'handleAngle',
'handleDistance',
'handleDistance',
],
"ClickSelectingTool": [
'canStart',
'doMouseUp',
],
"ActionTool": [
'canStart',
'doMouseDown',
'doMouseMove',
'doMouseUp',
'doCancel',
],
"ClickCreatingTool": [
'canStart',
'doMouseUp',
'insertPart',
'archetypeNodeData',
'archetypeNodeData',
'isDoubleClick',
'isDoubleClick',
'isGridSnapEnabled',
'isGridSnapEnabled',
],
"DragSelectingTool": [
'canStart',
'doActivate',
'doDeactivate',
'doMouseMove',
'doMouseUp',
'computeBoxBounds',
'selectInRect',
'delay',
'delay',
'isPartialInclusion',
'isPartialInclusion',
'box',
'box',
],
"PanningTool": [
'canStart',
'doActivate',
'doDeactivate',
'doCancel',
'doMouseMove',
'doMouseUp',
'bubbles',
'bubbles',
'originalPosition',
],
"HTMLInfo": [
'mainElement',
'mainElement',
'show',
'show',
'hide',
'hide',
'valueFunction',
'valueFunction',
],
"ContextMenuTool": [
'canStart',
'findObjectWithContextMenu',
'doActivate',
'doMouseDown',
'doMouseUp',
'doMouseMove',
'showContextMenu',
'positionContextMenu',
'hideContextMenu',
'showDefaultContextMenu',
'hideDefaultContextMenu',
'currentContextMenu',
'currentContextMenu',
'defaultTouchContextMenu',
'defaultTouchContextMenu',
'currentObject',
'currentObject',
'mouseDownPoint',
],
"TextEditingTool": [
'static LostFocus',
'static MouseDown',
'static Tab',
'static Enter',
'static SingleClick',
'static SingleClickSelected',
'static DoubleClick',
'static StateNone',
'static StateActive',
'static StateEditing',
'static StateValidating',
'static StateInvalid',
'static StateValidated',
'textBlock',
'textBlock',
'currentTextEditor',
'currentTextEditor',
'defaultTextEditor',
'defaultTextEditor',
'starting',
'starting',
'canStart',
'doStart',
'doActivate',
'doCancel',
'doMouseUp',
'doMouseDown',
'acceptText',
'doError',
'doSuccess',
'doDeactivate',
'isValidText',
'textValidation',
'textValidation',
'minimumEditorScale',
'selectsTextOnActivate',
'selectsTextOnActivate',
'state',
'state',
'measureTemporaryTextBlock',
],
"AnimationManager": [
'canStart',
'stopAnimation',
'isEnabled',
'isEnabled',
'duration',
'duration',
'isAnimating',
'isTicking',
'isInitial',
'isInitial',
'defaultAnimation',
'activeAnimations',
'initialAnimationStyle',
'initialAnimationStyle',
'static defineAnimationEffect',
'static Default',
'static AnimateLocations',
'static None',
],
"Animation": [
'suspend',
'advanceTo',
'start',
'addTemporaryPart',
'add',
'stop',
'duration',
'duration',
'reversible',
'reversible',
'runCount',
'runCount',
'finished',
'finished',
'easing',
'easing',
'isViewportUnconstrained',
'isViewportUnconstrained',
'isAnimating',
'getTemporaryState',
'static EaseLinear',
'static EaseInOutQuad',
'static EaseInQuad',
'static EaseOutQuad',
'static EaseInExpo',
'static EaseOutExpo',
],
"AnimationTrigger": [
'copy',
'propertyName',
'propertyName',
'animationSettings',
'startCondition',
'startCondition',
'static Default',
'static Immediate',
'static Bundled',
],
"Layer": [
'findObjectAt',
'findObjectsAt',
'findObjectsIn',
'findObjectsNear',
'parts',
'partsBackwards',
'diagram',
'name',
'name',
'opacity',
'opacity',
'isTemporary',
'isTemporary',
'visible',
'visible',
'pickable',
'pickable',
'isInDocumentBounds',
'isInDocumentBounds',
'allowCopy',
'allowCopy',
'allowDelete',
'allowDelete',
'allowTextEdit',
'allowTextEdit',
'allowGroup',
'allowGroup',
'allowUngroup',
'allowUngroup',
'allowLink',
'allowLink',
'allowRelink',
'allowRelink',
'allowMove',
'allowMove',
'allowReshape',
'allowReshape',
'allowResize',
'allowResize',
'allowRotate',
'allowRotate',
'allowSelect',
'allowSelect',
],
"Diagram": [

'static isUsingDOM',
'static useDOM',
'clear',
'reset',
'setRTL',
'setScrollWidth',
'static fromDiv',
'div',
'div',
'addEventListener',
'removeEventListener',
'computePixelRatio',
'doFocus',
'focus',
'computeBounds',
'computePartsBounds',
'zoomToFit',
'zoomToRect',
'alignDocument',
'focusObject',
'findPartAt',
'findObjectAt',
'findPartsAt',
'findObjectsAt',
'findPartsIn',
'findObjectsIn',
'findPartsNear',
'findObjectsNear',
'invalidateDocumentBounds',
'redraw',
'delayInitialization',
'requestUpdate',
'maybeUpdate',
'getRenderingHint',
'setRenderingHint',
'getInputOption',
'setInputOption',
'set',
'attach',
'setProperties',
'add',
'remove',
'removeParts',
'copyParts',
'moveParts',
'computeMove',
'draggedLink',
'addLayer',
'addLayerBefore',
'addLayerAfter',
'removeLayer',
'findLayer',
'addModelChangedListener',
'removeModelChangedListener',
'addChangedListener',
'removeChangedListener',
'animationManager',
'undoManager',
'skipsUndoManager',
'skipsUndoManager',
'delaysLayout',
'delaysLayout',
'startTransaction',
'commitTransaction',
'rollbackTransaction',
'commit',
'updateAllTargetBindings',
'updateAllRelationshipsFromData',
'clearSelection',
'select',
'selectCollection',
'clearHighlighteds',
'highlight',
'highlightCollection',
'scroll',
'scrollToRect',
'centerRect',
'transformDocToView',
'transformViewToDoc',
'static None',
'static Uniform',
'static UniformToFill',
'static CycleAll',
'static CycleNotDirected',
'static CycleNotUndirected',
'static CycleDestinationTree',
'static CycleSourceTree',
'static DocumentScroll',
'static InfiniteScroll',
'opacity',
'opacity',
'validCycle',
'validCycle',
'layers',
'isModelReadOnly',
'isModelReadOnly',
'isReadOnly',
'isReadOnly',
'isEnabled',
'isEnabled',
'allowClipboard',
'allowClipboard',
'allowCopy',
'allowCopy',
'allowDelete',
'allowDelete',
'allowDragOut',
'allowDragOut',
'allowDrop',
'allowDrop',
'allowTextEdit',
'allowTextEdit',
'allowGroup',
'allowGroup',
'allowUngroup',
'allowUngroup',
'allowInsert',
'allowInsert',
'allowLink',
'allowLink',
'allowRelink',
'allowRelink',
'allowMove',
'allowMove',
'allowReshape',
'allowReshape',
'allowResize',
'allowResize',
'allowRotate',
'allowRotate',
'allowSelect',
'allowSelect',
'allowUndo',
'allowUndo',
'allowZoom',
'allowZoom',
'hasVerticalScrollbar',
'hasVerticalScrollbar',
'hasHorizontalScrollbar',
'hasHorizontalScrollbar',
'allowHorizontalScroll',
'allowHorizontalScroll',
'allowVerticalScroll',
'allowVerticalScroll',
'scrollHorizontalLineChange',
'scrollHorizontalLineChange',
'scrollVerticalLineChange',
'scrollVerticalLineChange',
'lastInput',
'lastInput',
'previousInput',
'firstInput',
'firstInput',
'currentCursor',
'currentCursor',
'defaultCursor',
'defaultCursor',
'click',
'click',
'doubleClick',
'doubleClick',
'contextClick',
'contextClick',
'mouseOver',
'mouseOver',
'mouseHover',
'mouseHover',
'mouseHold',
'mouseHold',
'mouseDragOver',
'mouseDragOver',
'mouseDrop',
'mouseDrop',
'handlesDragDropForTopLevelParts',
'handlesDragDropForTopLevelParts',
'mouseEnter',
'mouseEnter',
'mouseLeave',
'mouseLeave',
'toolTip',
'toolTip',
'contextMenu',
'contextMenu',
'commandHandler',
'commandHandler',
'toolManager',
'toolManager',
'defaultTool',
'defaultTool',
'currentTool',
'currentTool',
'selection',
'maxSelectionCount',
'maxSelectionCount',
'nodeSelectionAdornmentTemplate',
'nodeSelectionAdornmentTemplate',
'groupSelectionAdornmentTemplate',
'groupSelectionAdornmentTemplate',
'linkSelectionAdornmentTemplate',
'linkSelectionAdornmentTemplate',
'highlighteds',
'isModified',
'isModified',
'model',
'model',
'static licenseKey',
'static licenseKey',
'static version',
'skipsModelSourceBindings',
'rebuildParts',
'findPartForKey',
'findNodeForKey',
'findLinkForKey',
'findPartForData',
'findNodeForData',
'findLinkForData',
'findNodesByExample',
'findLinksByExample',
'nodeTemplate',
'nodeTemplate',
'nodeTemplateMap',
'nodeTemplateMap',
'groupTemplate',
'groupTemplate',
'groupTemplateMap',
'groupTemplateMap',
'linkTemplate',
'linkTemplate',
'linkTemplateMap',
'linkTemplateMap',
'isMouseCaptured',
'isMouseCaptured',
'position',
'position',
'initialPosition',
'initialPosition',
'initialScale',
'initialScale',
'grid',
'grid',
'viewportBounds',
'viewSize',
'viewSize',
'fixedBounds',
'fixedBounds',
'scrollMargin',
'scrollMargin',
'scrollMode',
'scrollMode',
'scrollsPageOnFocus',
'scrollsPageOnFocus',
'positionComputation',
'positionComputation',
'scaleComputation',
'scaleComputation',
'documentBounds',
'ensureBounds',
'isVirtualized',
'isVirtualized',
'scale',
'scale',
'defaultScale',
'defaultScale',
'autoScale',
'autoScale',
'initialAutoScale',
'initialAutoScale',
'initialViewportSpot',
'initialViewportSpot',
'initialDocumentSpot',
'initialDocumentSpot',
'minScale',
'minScale',
'maxScale',
'maxScale',
'zoomPoint',
'zoomPoint',
'contentAlignment',
'contentAlignment',
'initialContentAlignment',
'initialContentAlignment',
'padding',
'padding',
'nodes',
'links',
'parts',
'findTopLevelGroups',
'layout',
'layout',
'layoutDiagram',
'isTreePathToChildren',
'isTreePathToChildren',
'findTreeRoots',
'treeCollapsePolicy',
'addDiagramListener',
'removeDiagramListener',
'raiseDiagramEvent',
'avoidanceCellSize',
'avoidanceCellSize',
'avoidanceLimit',
'avoidanceLimit',
'autoScrollInterval',
'autoScrollInterval',
'autoScrollRegion',
'autoScrollRegion',
'doAutoScroll',
'stopAutoScroll',
'computeAutoScrollPosition',
'makeSvg',
'addRenderer',
'cacheGroupExternalLinks',
'makeImage',
'makeImageData',
'static inherit',
],
"DraggingInfo": [
'point',
'point',
'shifted',
],
"DraggingOptions": [
'isGridSnapEnabled',
'isGridSnapRealtime',
'gridSnapCellSize',
'gridSnapCellSpot',
'gridSnapOrigin',
'dragsLink',
'dragsTree',
'groupsSnapMembers',
'groupsAlwaysMove',
'dragsMembers',
],

"Palette": [

],
"Overview": [

'observed',
'observed',
'box',
'box',
'drawsTemporaryLayers',
'drawsTemporaryLayers',
'drawsGrid',
'drawsGrid',
'updateDelay',
'updateDelay',
],
"CommandHandler": [
'diagram',
'doKeyDown',
'doKeyUp',
'stopCommand',
'canStopCommand',
'selectAll',
'canSelectAll',
'deleteSelection',
'canDeleteSelection',
'copySelection',
'canCopySelection',
'cutSelection',
'canCutSelection',
'copyToClipboard',
'pasteFromClipboard',
'pasteSelection',
'canPasteSelection',
'undo',
'canUndo',
'redo',
'canRedo',
'decreaseZoom',
'canDecreaseZoom',
'increaseZoom',
'canIncreaseZoom',
'resetZoom',
'canResetZoom',
'zoomToFit',
'canZoomToFit',
'scrollToPart',
'canScrollToPart',
'collapseTree',
'canCollapseTree',
'expandTree',
'canExpandTree',
'groupSelection',
'canGroupSelection',
'isValidMember',
'ungroupSelection',
'canUngroupSelection',
'addTopLevelParts',
'collapseSubGraph',
'canCollapseSubGraph',
'expandSubGraph',
'canExpandSubGraph',
'editTextBlock',
'canEditTextBlock',
'showContextMenu',
'canShowContextMenu',
'copiesClipboardData',
'copiesConnectedLinks',
'copiesConnectedLinks',
'deletesConnectedLinks',
'deletesConnectedLinks',
'copiesTree',
'copiesTree',
'deletesTree',
'deletesTree',
'copiesParentKey',
'copiesParentKey',
'copiesGroupKey',
'copiesGroupKey',
'archetypeGroupData',
'archetypeGroupData',
'memberValidation',
'memberValidation',
'defaultScale',
'defaultScale',
'zoomFactor',
'zoomFactor',
'isZoomToFitRestoreEnabled',
'isZoomToFitRestoreEnabled',
'scrollToPartPause',
'computeEffectiveCollection',
],

"GraphObject": [
'cloneProtected',
'copy',
'static None',
'static Default',
'static Vertical',
'static Horizontal',
'static Fill',
'static Uniform',
'static UniformToFill',
'static FlipVertical',
'static FlipHorizontal',
'static FlipBoth',
'getDocumentPoint',
'getDocumentBounds',
'getDocumentAngle',
'getDocumentScale',
'getLocalPoint',
'shadowVisible',
'shadowVisible',
'isContainedBy',
'isVisibleObject',
'isEnabledObject',
'enabledChanged',
'enabledChanged',
'segmentOrientation',
'segmentOrientation',
'segmentIndex',
'segmentIndex',
'segmentFraction',
'segmentFraction',
'segmentOffset',
'segmentOffset',
'stretch',
'stretch',
'name',
'name',
'opacity',
'opacity',
'visible',
'visible',
'pickable',
'pickable',
'fromLinkableDuplicates',
'fromLinkableDuplicates',
'fromLinkableSelfNode',
'fromLinkableSelfNode',
'toLinkableDuplicates',
'toLinkableDuplicates',
'toLinkableSelfNode',
'toLinkableSelfNode',
'isPanelMain',
'isPanelMain',
'isActionable',
'isActionable',
'areaBackground',
'areaBackground',
'background',
'background',
'part',
'svg',
'panel',
'layer',
'diagram',
'position',
'position',
'actualBounds',
'scale',
'scale',
'angle',
'angle',
'desiredSize',
'desiredSize',
'width',
'width',
'height',
'height',
'minSize',
'minSize',
'maxSize',
'maxSize',
'measuredBounds',
'naturalBounds',
'margin',
'margin',
'alignment',
'alignment',
'column',
'column',
'columnSpan',
'columnSpan',
'row',
'row',
'rowSpan',
'rowSpan',
'spanAllocation',
'spanAllocation',
'alignmentFocus',
'alignmentFocus',
'portId',
'portId',
'toSpot',
'toSpot',
'toEndSegmentLength',
'toEndSegmentLength',
'toShortLength',
'toShortLength',
'toLinkable',
'toLinkable',
'toMaxLinks',
'toMaxLinks',
'fromSpot',
'fromSpot',
'fromEndSegmentLength',
'fromEndSegmentLength',
'fromShortLength',
'fromShortLength',
'fromLinkable',
'fromLinkable',
'fromMaxLinks',
'fromMaxLinks',
'cursor',
'cursor',
'click',
'click',
'doubleClick',
'doubleClick',
'contextClick',
'contextClick',
'mouseEnter',
'mouseEnter',
'mouseLeave',
'mouseLeave',
'mouseOver',
'mouseOver',
'mouseHover',
'mouseHover',
'mouseHold',
'mouseHold',
'mouseDragEnter',
'mouseDragEnter',
'mouseDragLeave',
'mouseDragLeave',
'mouseDrop',
'mouseDrop',
'actionDown',
'actionDown',
'actionMove',
'actionMove',
'actionUp',
'actionUp',
'actionCancel',
'actionCancel',
'toolTip',
'toolTip',
'contextMenu',
'contextMenu',
'bind',
'bind',
'set',
'attach',
'apply',
'setProperties',
'static build',
'findTemplateBinder',
'findBindingPanel',
'trigger',
'static defineBuilder',
'static takeBuilderArgument',
],
"SGradient": [
],
"Brush": [
'copy',
'addColorStop',
'type',
'type',
'color',
'color',
'start',
'start',
'end',
'end',
'startRadius',
'startRadius',
'endRadius',
'endRadius',
'colorStops',
'colorStops',
'pattern',
'pattern',
'static randomColor',
'static isValidColor',
'static lighten',
'lightenBy',
'static lightenBy',
'static darken',
'darkenBy',
'static darkenBy',
'static mix',
'isDark',
'static isDark',
'static Solid',
'static Linear',
'static Radial',
'static Pattern',
'static Lab',
'static HSL',
],
"PanelLayout": [
'name',
'name',
'classType',
'measure',
'measureElement',
'arrange',
'arrangeElement',
'remeasureObject',
],
"Panel": [

'copy',
'type',
'type',
'elements',
'padding',
'padding',
'defaultAlignment',
'defaultAlignment',
'defaultStretch',
'defaultStretch',
'defaultSeparatorPadding',
'defaultSeparatorPadding',
'defaultRowSeparatorStroke',
'defaultRowSeparatorStroke',
'defaultRowSeparatorStrokeWidth',
'defaultRowSeparatorStrokeWidth',
'defaultRowSeparatorDashArray',
'defaultRowSeparatorDashArray',
'defaultColumnSeparatorStroke',
'defaultColumnSeparatorStroke',
'defaultColumnSeparatorStrokeWidth',
'defaultColumnSeparatorStrokeWidth',
'defaultColumnSeparatorDashArray',
'defaultColumnSeparatorDashArray',
'viewboxStretch',
'viewboxStretch',
'gridCellSize',
'gridCellSize',
'gridOrigin',
'gridOrigin',
'graduatedMin',
'graduatedMin',
'graduatedMax',
'graduatedMax',
'graduatedRange',
'graduatedTickUnit',
'graduatedTickUnit',
'graduatedTickBase',
'graduatedTickBase',
'findMainElement',
'findObject',
'add',
'elt',
'insertAt',
'remove',
'removeAt',
'rowCount',
'getRowDefinition',
'removeRowDefinition',
'columnCount',
'getColumnDefinition',
'removeColumnDefinition',
'rowSizing',
'rowSizing',
'columnSizing',
'columnSizing',
'topIndex',
'topIndex',
'leftIndex',
'leftIndex',
'findRowForLocalY',
'findColumnForLocalX',
'graduatedPointForValue',
'graduatedValueForPoint',
'data',
'data',
'itemIndex',
'itemIndex',
'copyTemplate',
'updateTargetBindings',
'itemArray',
'itemArray',
'findItemPanelForData',
'rebuildItemElements',
'itemTemplate',
'itemTemplate',
'itemTemplateMap',
'itemTemplateMap',
'itemCategoryProperty',
'itemCategoryProperty',
'isAtomic',
'isClipping',
'isClipping',
'isOpposite',
'isOpposite',
'isEnabled',
'isEnabled',
'alignmentFocusName',
'alignmentFocusName',
'static definePanelLayout',
'static Position',
'static Horizontal',
'static Vertical',
'static Spot',
'static Auto',
'static Table',
'static Viewbox',
'static TableRow',
'static TableColumn',
'static Link',
'static Grid',
'static Graduated',
],
"RowColumnDefinition": [
'static Default',
'static None',
'static ProportionalExtra',
'computeEffectiveSpacingTop',
'computeEffectiveSpacing',
'panel',
'isRow',
'isRow',
'index',
'index',
'height',
'height',
'width',
'width',
'minimum',
'minimum',
'maximum',
'maximum',
'alignment',
'alignment',
'stretch',
'stretch',
'separatorPadding',
'separatorPadding',
'separatorStroke',
'separatorStroke',
'separatorStrokeWidth',
'separatorStrokeWidth',
'separatorDashArray',
'separatorDashArray',
'background',
'background',
'coversSeparators',
'coversSeparators',
'sizing',
'sizing',
'actual',
'actual',
'measured',
'measured',
'total',
'position',
'position',
'bind',
'bind',
],
"Shape": [

'geometry',
'geometry',
'geometryString',
'geometryString',
'isGeometryPositioned',
'isGeometryPositioned',
'fill',
'fill',
'stroke',
'stroke',
'strokeWidth',
'strokeWidth',
'strokeCap',
'strokeCap',
'strokeJoin',
'strokeJoin',
'strokeMiterLimit',
'strokeMiterLimit',
'strokeDashArray',
'strokeDashArray',
'strokeDashOffset',
'strokeDashOffset',
'figure',
'figure',
'toArrow',
'toArrow',
'fromArrow',
'fromArrow',
'spot1',
'spot1',
'spot2',
'spot2',
'parameter1',
'parameter1',
'parameter2',
'parameter2',
'naturalBounds',
'pathPattern',
'pathPattern',
'geometryStretch',
'geometryStretch',
'interval',
'interval',
'graduatedStart',
'graduatedStart',
'graduatedEnd',
'graduatedEnd',
'graduatedSkip',
'graduatedSkip',
'static getFigureGenerators',
'static defineFigureGenerator',
'static getArrowheadGeometries',
'static defineArrowheadGeometry',
],
"TextBlock": [

'static getEllipsis',
'static setEllipsis',
'static getBaseline',
'static setBaseline',
'static getUnderline',
'static setUnderline',
'static None',
'static WrapFit',
'static WrapDesiredSize',
'static WrapBreakAll',
'static OverflowClip',
'static OverflowEllipsis',
'static FormatTrim',
'static FormatNone',
'font',
'font',
'static isValidFont',
'text',
'text',
'textAlign',
'textAlign',
'flip',
'flip',
'verticalAlignment',
'verticalAlignment',
'naturalBounds',
'isMultiline',
'isMultiline',
'isUnderline',
'isUnderline',
'isStrikethrough',
'isStrikethrough',
'wrap',
'wrap',
'overflow',
'overflow',
'stroke',
'stroke',
'lineCount',
'lineHeight',
'editable',
'editable',
'textEditor',
'textEditor',
'errorFunction',
'errorFunction',
'interval',
'interval',
'graduatedStart',
'graduatedStart',
'graduatedEnd',
'graduatedEnd',
'graduatedFunction',
'graduatedFunction',
'graduatedSkip',
'graduatedSkip',
'textValidation',
'textValidation',
'textEdited',
'textEdited',
'spacingAbove',
'spacingAbove',
'spacingBelow',
'spacingBelow',
'formatting',
'formatting',
'maxLines',
'maxLines',
'choices',
'choices',
],
"Picture": [

'static clearCache',
'element',
'element',
'source',
'source',
'reloadSource',
'redraw',
'sourceCrossOrigin',
'sourceCrossOrigin',
'sourceRect',
'sourceRect',
'imageStretch',
'imageStretch',
'flip',
'flip',
'imageAlignment',
'imageAlignment',
'errorFunction',
'errorFunction',
'successFunction',
'successFunction',
'naturalBounds',
],
"Part": [

'static LayoutNone',
'static LayoutAdded',
'static LayoutRemoved',
'static LayoutShown',
'static LayoutHidden',
'static LayoutNodeSized',
'static LayoutGroupLayout',
'static LayoutNodeReplaced',
'static LayoutStandard',
'updateTargetBindings',
'updateRelationshipsFromData',
'key',
'adornments',
'findAdornment',
'addAdornment',
'removeAdornment',
'clearAdornments',
'updateAdornments',
'invalidateAdornments',
'layer',
'diagram',
'layerName',
'layerName',
'layerChanged',
'layerChanged',
'zOrder',
'zOrder',
'locationObject',
'minLocation',
'minLocation',
'maxLocation',
'maxLocation',
'locationObjectName',
'locationObjectName',
'locationSpot',
'locationSpot',
'move',
'moveTo',
'isVisible',
'getDocumentBounds',
'ensureBounds',
'location',
'location',
'category',
'category',
'self',
'canCopy',
'canDelete',
'canEdit',
'canGroup',
'canMove',
'canReshape',
'canResize',
'canRotate',
'canSelect',
'copyable',
'copyable',
'deletable',
'deletable',
'textEditable',
'textEditable',
'groupable',
'groupable',
'movable',
'movable',
'selectionAdorned',
'selectionAdorned',
'isInDocumentBounds',
'isInDocumentBounds',
'isLayoutPositioned',
'isLayoutPositioned',
'selectable',
'selectable',
'reshapable',
'reshapable',
'resizable',
'resizable',
'rotatable',
'rotatable',
'isSelected',
'isSelected',
'isHighlighted',
'isHighlighted',
'isShadowed',
'isShadowed',
'isAnimated',
'isAnimated',
'highlightedChanged',
'highlightedChanged',
'selectionObjectName',
'selectionObjectName',
'selectionAdornmentTemplate',
'selectionAdornmentTemplate',
'selectionObject',
'selectionChanged',
'selectionChanged',
'resizeAdornmentTemplate',
'resizeAdornmentTemplate',
'resizeObjectName',
'resizeObjectName',
'resizeObject',
'resizeCellSize',
'resizeCellSize',
'rotateAdornmentTemplate',
'rotateAdornmentTemplate',
'rotateObjectName',
'rotateObjectName',
'rotateObject',
'rotationSpot',
'rotationSpot',
'text',
'text',
'containingGroup',
'containingGroup',
'containingGroupChanged',
'containingGroupChanged',
'findSubGraphLevel',
'findTopLevelPart',
'isTopLevel',
'isMemberOf',
'findCommonContainingGroup',
'layoutConditions',
'layoutConditions',
'canLayout',
'invalidateLayout',
'dragComputation',
'dragComputation',
'shadowOffset',
'shadowOffset',
'shadowColor',
'shadowColor',
'shadowBlur',
'shadowBlur',
],
"Adornment": [

'placeholder',
'adornedObject',
'adornedObject',
'adornedPart',
],
"Node": [

'static SpreadingNone',
'static SpreadingEvenly',
'static SpreadingPacked',
'invalidateLinkBundle',
'invalidateConnectedLinks',
'portSpreading',
'portSpreading',
'avoidable',
'avoidable',
'avoidableMargin',
'avoidableMargin',
'getAvoidableRect',
'findVisibleNode',
'linksConnected',
'findExternalTreeLinksConnected',
'findLinksConnected',
'findLinksOutOf',
'findLinksInto',
'findNodesConnected',
'findNodesOutOf',
'findNodesInto',
'findLinksBetween',
'findLinksTo',
'linkConnected',
'linkConnected',
'linkDisconnected',
'linkDisconnected',
'linkValidation',
'linkValidation',
'isLinkLabel',
'labeledLink',
'labeledLink',
'findPort',
'port',
'ports',
'isInTreeOf',
'findTreeRoot',
'findCommonTreeParent',
'findTreeParentLink',
'findTreeParentNode',
'findTreeParentChain',
'findTreeLevel',
'findTreeChildrenLinks',
'findTreeChildrenNodes',
'findTreeParts',
'collapseTree',
'expandTree',
'isTreeExpanded',
'isTreeExpanded',
'wasTreeExpanded',
'wasTreeExpanded',
'treeExpandedChanged',
'treeExpandedChanged',
'isTreeLeaf',
'isTreeLeaf',
],
"Group": [

'placeholder',
'computesBoundsAfterDrag',
'computesBoundsAfterDrag',
'computesBoundsIncludingLinks',
'computesBoundsIncludingLinks',
'computesBoundsIncludingLocation',
'computesBoundsIncludingLocation',
'handlesDragDropForMembers',
'handlesDragDropForMembers',
'memberParts',
'layout',
'layout',
'memberAdded',
'memberAdded',
'memberRemoved',
'memberRemoved',
'memberValidation',
'memberValidation',
'canAddMembers',
'addMembers',
'ungroupable',
'ungroupable',
'canUngroup',
'findExternalLinksConnected',
'findExternalNodesConnected',
'findSubGraphParts',
'collapseSubGraph',
'expandSubGraph',
'isSubGraphExpanded',
'isSubGraphExpanded',
'wasSubGraphExpanded',
'wasSubGraphExpanded',
'subGraphExpandedChanged',
'subGraphExpandedChanged',
'move',
],
"Placeholder": [
'computeBorder',
'computeMemberBounds',
'padding',
'padding',
],
"Link": [
'static Normal',
'static Orthogonal',
'static AvoidsNodes',
'static None',
'static Bezier',
'static JumpGap',
'static JumpOver',
'static End',
'static Scale',
'static Stretch',
'static OrientAlong',
'static OrientPlus90',
'static OrientMinus90',
'static OrientOpposite',
'static OrientUpright',
'static OrientPlus90Upright',
'static OrientMinus90Upright',
'static OrientUpright45',
'fromNode',
'fromNode',
'fromPortId',
'fromPortId',
'fromPort',
'fromPortChanged',
'fromPortChanged',
'toNode',
'toNode',
'toPortId',
'toPortId',
'toPort',
'toPortChanged',
'toPortChanged',
'fromSpot',
'fromSpot',
'fromEndSegmentLength',
'fromEndSegmentLength',
'fromShortLength',
'fromShortLength',
'toSpot',
'toSpot',
'toEndSegmentLength',
'toEndSegmentLength',
'toShortLength',
'toShortLength',
'getOtherNode',
'getOtherPort',
'isLabeledLink',
'labelNodes',
'move',
'relinkableFrom',
'relinkableFrom',
'relinkableTo',
'relinkableTo',
'canRelinkFrom',
'canRelinkTo',
'resegmentable',
'resegmentable',
'isTreeLink',
'isTreeLink',
'path',
'routeBounds',
'midPoint',
'midAngle',
'points',
'points',
'pointsCount',
'getPoint',
'setPoint',
'setPointAt',
'insertPoint',
'insertPointAt',
'addPoint',
'addPointAt',
'removePoint',
'clearPoints',
'startRoute',
'commitRoute',
'rollbackRoute',
'invalidateRoute',
'suspendsRouting',
'defaultFromPoint',
'defaultFromPoint',
'defaultToPoint',
'defaultToPoint',
'updateRoute',
'computePoints',
'getLinkPointFromPoint',
'getLinkPoint',
'getLinkDirection',
'computeEndSegmentLength',
'computeSpot',
'computeOtherPoint',
'computeShortLength',
'isOrthogonal',
'isAvoiding',
'computeCurve',
'computeCorner',
'findMidLabel',
'computeSpacing',
'arrangeBundledLinks',
'computeCurviness',
'computeThickness',
'hasCurviness',
'addOrthoPoints',
'computeMidOrthoPosition',
'findClosestSegment',
'geometry',
'makeGeometry',
'firstPickIndex',
'lastPickIndex',
'invalidateOtherJumpOvers',
'adjusting',
'adjusting',
'computeAdjusting',
'corner',
'corner',
'curve',
'curve',
'curviness',
'curviness',
'routing',
'routing',
'smoothness',
'smoothness',
'key',
],
"Layout": [
'cloneProtected',
'copy',
'diagram',
'diagram',
'group',
'group',
'isOngoing',
'isOngoing',
'isInitial',
'isInitial',
'isViewportSized',
'isViewportSized',
'isRouting',
'isRouting',
'isRealtime',
'isRealtime',
'isValidLayout',
'isValidLayout',
'invalidateLayout',
'network',
'network',
'createNetwork',
'makeNetwork',
'updateParts',
'commitLayout',
'doLayout',
'getLayoutBounds',
'boundsComputation',
'boundsComputation',
'collectParts',
'arrangementOrigin',
'arrangementOrigin',
'initialOrigin',
'id',
'mayUseWorkerFunction',
'workerStateChanged',
],
"LayoutNetwork": [
'layout',
'layout',
'vertexes',
'edges',
'createVertex',
'createEdge',
'addParts',
'addVertex',
'addNode',
'deleteVertex',
'deleteNode',
'findVertex',
'addEdge',
'addLink',
'deleteEdge',
'deleteLink',
'findEdge',
'linkVertexes',
'reverseEdge',
'deleteSelfEdges',
'deleteArtificialVertexes',
'splitIntoSubNetworks',
'findAllParts',
],
"LayoutVertex": [
'sourceEdgesArrayAccess',
'destinationEdgesArrayAccess',
'data',
'data',
'node',
'node',
'bounds',
'bounds',
'focus',
'focus',
'centerX',
'centerX',
'centerY',
'centerY',
'focusX',
'focusX',
'focusY',
'focusY',
'x',
'x',
'y',
'y',
'width',
'width',
'height',
'height',
'commit',
'addSourceEdge',
'deleteSourceEdge',
'addDestinationEdge',
'deleteDestinationEdge',
'network',
'network',
'sourceVertexes',
'destinationVertexes',
'vertexes',
'sourceEdges',
'destinationEdges',
'edges',
'edgesCount',
'static standardComparer',
'static smartComparer',
],
"LayoutEdge": [
'commit',
'getOtherVertex',
'network',
'network',
'data',
'data',
'link',
'link',
'fromVertex',
'fromVertex',
'toVertex',
'toVertex',
],
"GridLayout": [
'doLayout',
'wrappingWidth',
'wrappingWidth',
'wrappingColumn',
'wrappingColumn',
'cellSize',
'cellSize',
'spacing',
'spacing',
'alignment',
'alignment',
'arrangement',
'arrangement',
'sorting',
'sorting',
'comparer',
'comparer',
'static Position',
'static Location',
'static LeftToRight',
'static RightToLeft',
'static Forward',
'static Reverse',
'static Ascending',
'static Descending',
],


"Model": [

'cloneProtected',
'copy',
'clear',
'toIncrementalData',
'cloneDeep',
'toIncrementalJson',
'toJson',
'applyIncrementalJson',
'static fromJson',
'name',
'name',
'dataFormat',
'dataFormat',
'isReadOnly',
'isReadOnly',
'modelData',
'modelData',
'addChangedListener',
'removeChangedListener',
'raiseChangedEvent',
'raiseDataChanged',
'undoManager',
'undoManager',
'skipsUndoManager',
'skipsUndoManager',
'changeState',
'startTransaction',
'commitTransaction',
'rollbackTransaction',
'commit',
'updateTargetBindings',
'nodeKeyProperty',
'nodeKeyProperty',
'getKeyForNodeData',
'setKeyForNodeData',
'makeUniqueKeyFunction',
'makeUniqueKeyFunction',
'containsNodeData',
'findNodeDataForKey',
'nodeDataArray',
'nodeDataArray',
'makeNodeDataKeyUnique',
'addNodeData',
'addNodeDataCollection',
'removeNodeData',
'removeNodeDataCollection',
'mergeNodeDataArray',
'clearUnresolvedReferences',
'copyNodeDataFunction',
'copyNodeDataFunction',
'copiesArrays',
'copiesArrays',
'copiesArrayObjects',
'copiesArrayObjects',
'copiesKey',
'copiesKey',
'copyNodeData',
'afterCopyFunction',
'afterCopyFunction',
'setDataProperty',
'set',
'assignAllDataProperties',
'addArrayItem',
'insertArrayItem',
'removeArrayItem',
'nodeCategoryProperty',
'nodeCategoryProperty',
'getCategoryForNodeData',
'setCategoryForNodeData',
],
"Binding": [
'copy',
'static OneWay',
'static TwoWay',
'static parseEnum',
'static toString',
'targetProperty',
'targetProperty',
'sourceName',
'sourceName',
'isToModel',
'isToModel',
'sourceProperty',
'sourceProperty',
'converter',
'converter',
'backConverter',
'backConverter',
'mode',
'mode',
'makeTwoWay',
'ofObject',
'ofModel',
],
"GraphLinksModel": [

'archetypeNodeData',
'archetypeNodeData',
'linkFromKeyProperty',
'linkFromKeyProperty',
'getFromKeyForLinkData',
'setFromKeyForLinkData',
'linkToKeyProperty',
'linkToKeyProperty',
'getToKeyForLinkData',
'setToKeyForLinkData',
'linkFromPortIdProperty',
'linkFromPortIdProperty',
'getFromPortIdForLinkData',
'setFromPortIdForLinkData',
'linkToPortIdProperty',
'linkToPortIdProperty',
'getToPortIdForLinkData',
'setToPortIdForLinkData',
'linkLabelKeysProperty',
'linkLabelKeysProperty',
'getLabelKeysForLinkData',
'setLabelKeysForLinkData',
'addLabelKeyForLinkData',
'removeLabelKeyForLinkData',
'linkDataArray',
'linkDataArray',
'linkKeyProperty',
'linkKeyProperty',
'getKeyForLinkData',
'setKeyForLinkData',
'makeUniqueLinkKeyFunction',
'makeUniqueLinkKeyFunction',
'findLinkDataForKey',
'makeLinkDataKeyUnique',
'containsLinkData',
'addLinkData',
'addLinkDataCollection',
'removeLinkData',
'removeLinkDataCollection',
'mergeLinkDataArray',
'copyLinkDataFunction',
'copyLinkDataFunction',
'copyLinkData',
'nodeIsGroupProperty',
'nodeIsGroupProperty',
'isGroupForNodeData',
'nodeGroupKeyProperty',
'nodeGroupKeyProperty',
'getGroupKeyForNodeData',
'setGroupKeyForNodeData',
'copyNodeData',
'setDataProperty',
'assignAllDataProperties',
'linkCategoryProperty',
'linkCategoryProperty',
'getCategoryForLinkData',
'setCategoryForLinkData',
],
"TreeModel": [

'nodeParentKeyProperty',
'nodeParentKeyProperty',
'getParentKeyForNodeData',
'setParentKeyForNodeData',
'parentLinkCategoryProperty',
'parentLinkCategoryProperty',
'linkCategoryProperty',
'getParentLinkCategoryForNodeData',
'setParentLinkCategoryForNodeData',
'copyNodeData',
'setDataProperty',
],
"CircularLayout": [
'createNetwork',
'doLayout',
'commitLayout',
'commitNodes',
'commitLinks',
'radius',
'radius',
'aspectRatio',
'aspectRatio',
'startAngle',
'startAngle',
'sweepAngle',
'sweepAngle',
'arrangement',
'arrangement',
'direction',
'direction',
'sorting',
'sorting',
'comparer',
'comparer',
'spacing',
'spacing',
'nodeDiameterFormula',
'nodeDiameterFormula',
'actualXRadius',
'actualYRadius',
'actualSpacing',
'actualCenter',
'static ConstantSpacing',
'static ConstantDistance',
'static ConstantAngle',
'static Packed',
'static Clockwise',
'static Counterclockwise',
'static BidirectionalLeft',
'static BidirectionalRight',
'static Forwards',
'static Reverse',
'static Ascending',
'static Descending',
'static Optimized',
'static Pythagorean',
'static Circular',
],
"CircularNetwork": [
],
"CircularVertex": [
'diameter',
'diameter',
'actualAngle',
'actualAngle',
],
"CircularEdge": [
],
"ForceDirectedLayout": [
'createNetwork',
'doLayout',
'addComments',
'moveVertex',
'moveFixedVertex',
'commitLayout',
'commitNodes',
'commitLinks',
'springStiffness',
'springLength',
'electricalCharge',
'electricalFieldX',
'electricalFieldY',
'gravitationalMass',
'gravitationalFieldX',
'gravitationalFieldY',
'isFixed',
'currentIteration',
'arrangementSpacing',
'arrangementSpacing',
'arrangesToOrigin',
'arrangesToOrigin',
'setsPortSpots',
'setsPortSpots',
'comments',
'comments',
'maxIterations',
'maxIterations',
'epsilonDistance',
'epsilonDistance',
'infinityDistance',
'infinityDistance',
'moveLimit',
'moveLimit',
'randomNumberGenerator',
'randomNumberGenerator',
'defaultSpringStiffness',
'defaultSpringStiffness',
'defaultSpringLength',
'defaultSpringLength',
'defaultElectricalCharge',
'defaultElectricalCharge',
'defaultGravitationalMass',
'defaultGravitationalMass',
'defaultCommentSpringLength',
'defaultCommentSpringLength',
'defaultCommentElectricalCharge',
'defaultCommentElectricalCharge',
],
"ForceDirectedNetwork": [
],
"ForceDirectedVertex": [
'isFixed',
'isFixed',
'charge',
'charge',
'mass',
'mass',
'forceX',
'forceX',
'forceY',
'forceY',
],
"ForceDirectedEdge": [
'stiffness',
'stiffness',
'length',
'length',
],
"LayeredDigraphLayout": [
'createNetwork',
'doLayout',
'linkMinLength',
'nodeMinLayerSpace',
'nodeMinColumnSpace',
'removeCycles',
'assignLayers',
'initializeIndices',
'reduceCrossings',
'straightenAndPack',
'commitLayout',
'commitNodes',
'commitLayers',
'commitLinks',
'layerSpacing',
'layerSpacing',
'columnSpacing',
'columnSpacing',
'direction',
'direction',
'cycleRemoveOption',
'cycleRemoveOption',
'layeringOption',
'layeringOption',
'initializeOption',
'initializeOption',
'iterations',
'iterations',
'aggressiveOption',
'aggressiveOption',
'packOption',
'packOption',
'setsPortSpots',
'setsPortSpots',
'linkSpacing',
'linkSpacing',
'maxLayer',
'maxIndex',
'maxColumn',
'minIndexLayer',
'maxIndexLayer',
'static CycleDepthFirst',
'static CycleGreedy',
'static CycleFromLayers',
'static LayerOptimalLinkLength',
'static LayerLongestPathSink',
'static LayerLongestPathSource',
'static InitDepthFirstOut',
'static InitDepthFirstIn',
'static InitNaive',
'static AggressiveNone',
'static AggressiveLess',
'static AggressiveMore',
'static PackNone',
'static PackExpand',
'static PackStraighten',
'static PackMedian',
'static PackAll',
],
"LayeredDigraphNetwork": [
],
"LayeredDigraphVertex": [
'layer',
'layer',
'column',
'column',
'index',
'index',
'component',
'component',
'near',
'near',
],
"LayeredDigraphEdge": [
'fromVertex',
'fromVertex',
'toVertex',
'toVertex',
'valid',
'valid',
'rev',
'rev',
'forest',
'forest',
'portFromPos',
'portFromPos',
'portToPos',
'portToPos',
'portFromColOffset',
'portFromColOffset',
'portToColOffset',
'portToColOffset',
],
"TreeLayout": [
'createNetwork',
'makeNetwork',
'doLayout',
'initializeTreeVertexValues',
'assignTreeVertexValues',
'addComments',
'layoutComments',
'arrangeTrees',
'commitLayout',
'commitNodes',
'commitLayers',
'commitLinks',
'roots',
'roots',
'path',
'path',
'treeStyle',
'treeStyle',
'layerStyle',
'layerStyle',
'comments',
'comments',
'arrangement',
'arrangement',
'arrangementSpacing',
'arrangementSpacing',
'rootDefaults',
'rootDefaults',
'alternateDefaults',
'alternateDefaults',
'sorting',
'sorting',
'comparer',
'comparer',
'angle',
'angle',
'alignment',
'alignment',
'nodeIndent',
'nodeIndent',
'nodeIndentPastParent',
'nodeIndentPastParent',
'nodeSpacing',
'nodeSpacing',
'layerSpacing',
'layerSpacing',
'layerSpacingParentOverlap',
'layerSpacingParentOverlap',
'compaction',
'compaction',
'breadthLimit',
'breadthLimit',
'rowSpacing',
'rowSpacing',
'rowIndent',
'rowIndent',
'commentSpacing',
'commentSpacing',
'commentMargin',
'commentMargin',
'setsPortSpot',
'setsPortSpot',
'portSpot',
'portSpot',
'setsChildPortSpot',
'setsChildPortSpot',
'childPortSpot',
'childPortSpot',
'alternateSorting',
'alternateSorting',
'alternateComparer',
'alternateComparer',
'alternateAngle',
'alternateAngle',
'alternateAlignment',
'alternateAlignment',
'alternateNodeIndent',
'alternateNodeIndent',
'alternateNodeIndentPastParent',
'alternateNodeIndentPastParent',
'alternateNodeSpacing',
'alternateNodeSpacing',
'alternateLayerSpacing',
'alternateLayerSpacing',
'alternateLayerSpacingParentOverlap',
'alternateLayerSpacingParentOverlap',
'alternateCompaction',
'alternateCompaction',
'alternateBreadthLimit',
'alternateBreadthLimit',
'alternateRowSpacing',
'alternateRowSpacing',
'alternateRowIndent',
'alternateRowIndent',
'alternateCommentSpacing',
'alternateCommentSpacing',
'alternateCommentMargin',
'alternateCommentMargin',
'alternateSetsPortSpot',
'alternateSetsPortSpot',
'alternatePortSpot',
'alternatePortSpot',
'alternateSetsChildPortSpot',
'alternateSetsChildPortSpot',
'alternateChildPortSpot',
'alternateChildPortSpot',
'static PathDefault',
'static PathDestination',
'static PathSource',
'static SortingForwards',
'static SortingReverse',
'static SortingAscending',
'static SortingDescending',
'static AlignmentCenterSubtrees',
'static AlignmentCenterChildren',
'static AlignmentStart',
'static AlignmentEnd',
'static AlignmentBus',
'static AlignmentBusBranching',
'static AlignmentTopLeftBus',
'static AlignmentBottomRightBus',
'static CompactionNone',
'static CompactionBlock',
'static StyleLayered',
'static StyleLastParents',
'static StyleAlternating',
'static StyleRootOnly',
'static ArrangementVertical',
'static ArrangementHorizontal',
'static ArrangementFixedRoots',
'static LayerIndividual',
'static LayerSiblings',
'static LayerUniform',
],
"TreeNetwork": [
],
"TreeVertex": [
'copyInheritedPropertiesFrom',
'initialized',
'initialized',
'parent',
'parent',
'children',
'children',
'level',
'level',
'descendantCount',
'descendantCount',
'maxChildrenCount',
'maxChildrenCount',
'maxGenerationCount',
'maxGenerationCount',
'comments',
'comments',
'sorting',
'sorting',
'comparer',
'comparer',
'angle',
'angle',
'alignment',
'alignment',
'nodeIndent',
'nodeIndent',
'nodeIndentPastParent',
'nodeIndentPastParent',
'nodeSpacing',
'nodeSpacing',
'layerSpacing',
'layerSpacing',
'layerSpacingParentOverlap',
'layerSpacingParentOverlap',
'compaction',
'compaction',
'breadthLimit',
'breadthLimit',
'rowSpacing',
'rowSpacing',
'rowIndent',
'rowIndent',
'commentSpacing',
'commentSpacing',
'commentMargin',
'commentMargin',
'setsPortSpot',
'setsPortSpot',
'portSpot',
'portSpot',
'setsChildPortSpot',
'setsChildPortSpot',
'childPortSpot',
'childPortSpot',
'childrenCount',
'relativePosition',
'relativePosition',
'subtreeSize',
'subtreeSize',
'subtreeOffset',
'subtreeOffset',
],
"TreeEdge": [
'commit',
'fromVertex',
'fromVertex',
'toVertex',
'toVertex',
'relativePoint',
'relativePoint',
]


    }

    for (var k in allClasses) {
      var methods = allClasses[k];
      // console.log(k);
      for (var i = 0; i < methods.length; i++) {
        var methodName = methods[i];
        if (methodName === "length" || methodName === "count") continue; // go.List.prototype.length DNE, inexplicably
        // These switch from get/set properties to literal properties on compilation
        switch (methodName) {
          case "x":
          case "y":
          case "width":
          case "height":
          case "offsetX":
          case "offsetY":
          case "top":
          case "left":
          case "bottom":
          case "right":
            continue;
        }

        // DraggingOptions uses real properties and not getters/setters do they don't show up in getOwnPropertyNames
        if (k === "DraggingOptions") {
          var instance = new go[k]();
          test.assert(instance[methodName] !== undefined, 'property ' + k + ' does not seem to have ' + methodName)
          continue;
        }

        if (methodName.indexOf('static ') === 0) {
          // static method k.methodName
          test.assert((go[k][methodName.split(' ')[1]] !== undefined), "Class " + k + " does not expose " + methodName);
        } else {
          // console.log(go[k].prototype[methodName] !== undefined);
          test.assert(Object.getOwnPropertyNames(go[k].prototype).indexOf(methodName) >= 0, 'property ' + k + ' does not seem to have ' + methodName);
        }
        // console.log('  ' + methods[i]);
      }

    }

  }, null, function (test) { }
  )); // end test

  })(); // end test system

